--yearclock by mrpeachy
require 'cairo'

function conky_draw_clock()
if conky_window == nil then return end
local cs = cairo_xlib_surface_create(conky_window.display, conky_window.drawable, conky_window.visual, conky_window.width, conky_window.height)
cr = cairo_create(cs)
-- not using CPU do not need the following two lines nor the second last 'end'
-- local updates=tonumber(conky_parse('${updates}'))
-- if updates > 5 then

--year clock
year=os.date("%G")
t1 = os.time( {    year=year,month=03,day=01,hour=00,min=0,sec=0} );
t2 = os.time( {    year=year,month=02,day=01,hour=00,min=0,sec=0} );
feb=(os.difftime(t1,t2))/(24*60*60)
yeardays=31+feb+31+30+31+30+31+31+30+31+30+31
monthdays = { 31, feb, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 }
yearsec=yeardays*24*60*60

rad=60
across=300
down=300
yrlw=1	-- yr (months) circle - lw = line width

circrad=rad
circx=across
circy=down
cairo_arc(cr,circx,circy,circrad,0,2*math.pi)
cairo_close_path(cr)
cairo_set_source_rgba(cr,0.00,0.00,0.00,1) -- circle colour: Black
cairo_set_line_width(cr, yrlw)
cairo_stroke (cr)

--hours
hrs=os.date("%H")
--minutes
min=os.date("%M")
--seconds
sec=os.date("%S")
--day of month
day=os.date("%e")
--month-1
month=os.date("%m")
--position in the year indicator
mdays=0
for i=1,(month-1) do
mdays=mdays+monthdays[i]
end
yrsecs=(mdays*24*60*60)+(day*24*60*60)+(hrs*60*60)+(min*60)+(sec)
cairo_translate (cr, across, down)
outer1=rad
text_arc=((2*math.pi/(yearsec))*yrsecs)
yrx=0+outer1*(math.sin(text_arc))
yry=0-outer1*(math.cos(text_arc))
circrad=6 --6
circx=yrx
circy=yry
cairo_arc(cr,circx,circy,circrad,0,2*math.pi)
cairo_close_path(cr)
cairo_set_source_rgba(cr,0.00,0.00,0.00,1)  -- dot color Black
cairo_fill (cr)
cairo_translate (cr, -across, -down)

--day of the month indicator
rad=50
across=yrx+across
down=yry+down
mnlw=1

circrad=rad
circx=across
circy=down
cairo_arc(cr,circx,circy,circrad,0,2*math.pi)
cairo_close_path(cr)
cairo_set_source_rgba(cr,0.47,0.53,0.60,1) -- circle colour: LightSlateGray
cairo_set_line_width(cr, mnlw)
cairo_stroke (cr)

mndays=(monthdays[tonumber(month)])*24*60*60
mnday=(day*24*60*60)+(hrs*60*60)+(min*60)+(sec)
cairo_translate (cr, across, down)
outer1=rad
text_arc=((2*math.pi/(mndays))*mnday)
mnx=0+outer1*(math.sin(text_arc))
mny=0-outer1*(math.cos(text_arc))
circrad=6 --5
circx=mnx
circy=mny
cairo_arc(cr,circx,circy,circrad,0,2*math.pi)
cairo_close_path(cr)
cairo_set_source_rgba(cr,0.47,0.53,0.60,1) -- dot colour: LightSlateGray
cairo_fill (cr)
cairo_translate (cr, -across, -down)

--hours of the day
rad=40
across=mnx+across
down=mny+down
dylw=1

circrad=rad
circx=across
circy=down
cairo_arc(cr,circx,circy,circrad,0,2*math.pi)
cairo_close_path(cr)
cairo_set_source_rgba(cr,0.86,0.86,0.86,1) -- circle colour: Gainsboro
cairo_set_line_width(cr, dylw)
cairo_stroke (cr)

hours=24*60*60
hour=(hrs*60*60)+(min*60)+(sec)
cairo_translate (cr, across, down)
outer1=rad
text_arc=((2*math.pi/(hours))*hour)
dyx=0+outer1*(math.sin(text_arc))
dyy=0-outer1*(math.cos(text_arc))
circrad=6 --4
circx=dyx
circy=dyy
cairo_arc(cr,circx,circy,circrad,0,2*math.pi)
cairo_close_path(cr)
cairo_set_source_rgba(cr,0.86,0.86,0.86,1) -- dot colour: Gainsboro
cairo_fill (cr)
cairo_translate (cr, -across, -down)

--minutes of hour indicator
rad=30
across=dyx+across
down=dyy+down
hrlw=1

circrad=rad
circx=across
circy=down
cairo_arc(cr,circx,circy,circrad,0,2*math.pi)
cairo_close_path(cr)
cairo_set_source_rgba(cr,0.00,0.75,1.00,1) -- circle colour: DeepSkyBlue
cairo_set_line_width(cr, hrlw)
cairo_stroke (cr)

minutes=60*60
minute=(min*60)+(sec)
cairo_translate (cr, across, down)
outer1=rad
text_arc=((2*math.pi/(minutes))*minute)
hrx=0+outer1*(math.sin(text_arc))
hry=0-outer1*(math.cos(text_arc))
circrad=6 --3
circx=hrx
circy=hry
cairo_arc(cr,circx,circy,circrad,0,2*math.pi)
cairo_close_path(cr)
cairo_set_source_rgba(cr,0.00,0.75,1.00,1) -- circle colour: DeepSkyBlue
cairo_fill (cr)
cairo_translate (cr, -across, -down)

--seconds of minute indicator
rad=20
across=hrx+across
down=hry+down
seclw=1

circrad=rad
circx=across
circy=down
cairo_arc(cr,circx,circy,circrad,0,2*math.pi)
cairo_close_path(cr)
cairo_set_source_rgba(cr,1.00,0.27,0.00,1) -- circle colour: OrangeRed
cairo_set_line_width(cr, seclw)
cairo_stroke (cr)
seconds=60
second=(sec)
cairo_translate (cr, across, down)
outer1=rad
text_arc=((2*math.pi/(seconds))*second)
scx=0+outer1*(math.sin(text_arc))
scy=0-outer1*(math.cos(text_arc))
circrad=6 --2
circx=scx
circy=scy
cairo_arc(cr,circx,circy,circrad,0,2*math.pi)
cairo_close_path(cr)
cairo_set_source_rgba(cr,1.00,0.27,0.00,1) -- circle colour: OrangeRed
cairo_fill (cr)
cairo_translate (cr, -across, -down)
-- end
end 
